{
  FreePascal translation of libhal-storage.h
}
  {**************************************************************************
   * CVSID: $Id$
   *
   * libhal-storage.h : HAL convenience library for storage devices and volumes
   *
   * Copyright (C) 2004 Red Hat, Inc.
   *
   * Author: David Zeuthen <davidz@redhat.com>
   *
   * Licensed under the Academic Free License version 2.1
   *
   * This program is free software; you can redistribute it and/or modify
   * it under the terms of the GNU General Public License as published by
   * the Free Software Foundation; either version 2 of the License, or
   * (at your option) any later version.
   *
   * This program is distributed in the hope that it will be useful,
   * but WITHOUT ANY WARRANTY; without even the implied warranty of
   * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   * GNU General Public License for more details.
   *
   * You should have received a copy of the GNU General Public License
   * along with this program; if not, write to the Free Software
   * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
   *
   ************************************************************************* }

unit libhalstorage;

{$IFDEF FPC}
{$MODE objfpc}{$H+}
{$PACKRECORDS C}
{$ENDIF}

interface

uses
   dbus, libhal;

const
  External_library = 'libhal-storage';

type
  PLibHalDrive = Pointer;
  PLibHalStoragePolicy = Pointer;
  PLibHalStoragePolicyIconPair = Pointer;
  PLibHalVolume = Pointer;

type

  LibHalStoragePolicyIcon = (LIBHAL_STORAGE_ICON_DRIVE_REMOVABLE_DISK := $10000,
    LIBHAL_STORAGE_ICON_DRIVE_REMOVABLE_DISK_IDE := $10001,
    LIBHAL_STORAGE_ICON_DRIVE_REMOVABLE_DISK_SCSI := $10002,
    LIBHAL_STORAGE_ICON_DRIVE_REMOVABLE_DISK_USB := $10003,
    LIBHAL_STORAGE_ICON_DRIVE_REMOVABLE_DISK_IEEE1394 := $10004,
    LIBHAL_STORAGE_ICON_DRIVE_DISK := $10100,
    LIBHAL_STORAGE_ICON_DRIVE_DISK_IDE := $10101,
    LIBHAL_STORAGE_ICON_DRIVE_DISK_SCSI := $10102,
    LIBHAL_STORAGE_ICON_DRIVE_DISK_USB := $10103,
    LIBHAL_STORAGE_ICON_DRIVE_DISK_IEEE1394 := $10104,
    LIBHAL_STORAGE_ICON_DRIVE_CDROM := $10200,
    LIBHAL_STORAGE_ICON_DRIVE_CDROM_IDE := $10201,
    LIBHAL_STORAGE_ICON_DRIVE_CDROM_SCSI := $10202,
    LIBHAL_STORAGE_ICON_DRIVE_CDROM_USB := $10203,
    LIBHAL_STORAGE_ICON_DRIVE_CDROM_IEEE1394 := $10204,
    LIBHAL_STORAGE_ICON_DRIVE_FLOPPY := $10300,
    LIBHAL_STORAGE_ICON_DRIVE_FLOPPY_IDE := $10301,
    LIBHAL_STORAGE_ICON_DRIVE_FLOPPY_SCSI := $10302,
    LIBHAL_STORAGE_ICON_DRIVE_FLOPPY_USB := $10303,
    LIBHAL_STORAGE_ICON_DRIVE_FLOPPY_IEEE1394 := $10304,
    LIBHAL_STORAGE_ICON_DRIVE_TAPE := $10400,
    LIBHAL_STORAGE_ICON_DRIVE_COMPACT_FLASH := $10500,
    LIBHAL_STORAGE_ICON_DRIVE_MEMORY_STICK := $10600,
    LIBHAL_STORAGE_ICON_DRIVE_SMART_MEDIA := $10700,
    LIBHAL_STORAGE_ICON_DRIVE_SD_MMC := $10800,
    LIBHAL_STORAGE_ICON_DRIVE_CAMERA := $10900,
    LIBHAL_STORAGE_ICON_DRIVE_PORTABLE_AUDIO_PLAYER := $10A00,
    LIBHAL_STORAGE_ICON_DRIVE_ZIP := $10B00,
    LIBHAL_STORAGE_ICON_DRIVE_JAZ := $10C00,
    LIBHAL_STORAGE_ICON_DRIVE_FLASH_KEY := $10D00,
    LIBHAL_STORAGE_ICON_VOLUME_REMOVABLE_DISK := $20000,
    LIBHAL_STORAGE_ICON_VOLUME_REMOVABLE_DISK_IDE := $20001,
    LIBHAL_STORAGE_ICON_VOLUME_REMOVABLE_DISK_SCSI := $20002,
    LIBHAL_STORAGE_ICON_VOLUME_REMOVABLE_DISK_USB := $20003,
    LIBHAL_STORAGE_ICON_VOLUME_REMOVABLE_DISK_IEEE1394 := $20004,
    LIBHAL_STORAGE_ICON_VOLUME_DISK := $20100,
    LIBHAL_STORAGE_ICON_VOLUME_DISK_IDE := $20101,
    LIBHAL_STORAGE_ICON_VOLUME_DISK_SCSI := $20102,
    LIBHAL_STORAGE_ICON_VOLUME_DISK_USB := $20103,
    LIBHAL_STORAGE_ICON_VOLUME_DISK_IEEE1394 := $20104,
    LIBHAL_STORAGE_ICON_VOLUME_CDROM := $20200,
    LIBHAL_STORAGE_ICON_VOLUME_CDROM_IDE := $20201,
    LIBHAL_STORAGE_ICON_VOLUME_CDROM_SCSI := $20202,
    LIBHAL_STORAGE_ICON_VOLUME_CDROM_USB := $20203,
    LIBHAL_STORAGE_ICON_VOLUME_CDROM_IEEE1394 := $20204,
    LIBHAL_STORAGE_ICON_VOLUME_FLOPPY := $20300,
    LIBHAL_STORAGE_ICON_VOLUME_FLOPPY_IDE := $20301,
    LIBHAL_STORAGE_ICON_VOLUME_FLOPPY_SCSI := $20302,
    LIBHAL_STORAGE_ICON_VOLUME_FLOPPY_USB := $20303,
    LIBHAL_STORAGE_ICON_VOLUME_FLOPPY_IEEE1394 := $20304,
    LIBHAL_STORAGE_ICON_VOLUME_TAPE := $20400,
    LIBHAL_STORAGE_ICON_VOLUME_COMPACT_FLASH := $20500,
    LIBHAL_STORAGE_ICON_VOLUME_MEMORY_STICK := $20600,
    LIBHAL_STORAGE_ICON_VOLUME_SMART_MEDIA := $20700,
    LIBHAL_STORAGE_ICON_VOLUME_SD_MMC := $20800,
    LIBHAL_STORAGE_ICON_VOLUME_CAMERA := $20900,
    LIBHAL_STORAGE_ICON_VOLUME_PORTABLE_AUDIO_PLAYER := $20A00,
    LIBHAL_STORAGE_ICON_VOLUME_ZIP := $20B00,
    LIBHAL_STORAGE_ICON_VOLUME_JAZ := $20C00,
    LIBHAL_STORAGE_ICON_VOLUME_FLASH_KEY := $20D00,
    LIBHAL_STORAGE_ICON_DISC_CDROM := $30000,
    LIBHAL_STORAGE_ICON_DISC_CDR := $30001,
    LIBHAL_STORAGE_ICON_DISC_CDRW := $30002,
    LIBHAL_STORAGE_ICON_DISC_DVDROM := $30003,
    LIBHAL_STORAGE_ICON_DISC_DVDRAM := $30004,
    LIBHAL_STORAGE_ICON_DISC_DVDR := $30005,
    LIBHAL_STORAGE_ICON_DISC_DVDRW := $30006,
    LIBHAL_STORAGE_ICON_DISC_DVDPLUSR := $30007,
    LIBHAL_STORAGE_ICON_DISC_DVDPLUSRW := $30008,
    LIBHAL_STORAGE_ICON_DISC_DVDPLUSRWDL := $30009,
    LIBHAL_STORAGE_ICON_DISC_BDROM := $3000A,
    LIBHAL_STORAGE_ICON_DISC_BDR := $3000B,
    LIBHAL_STORAGE_ICON_DISC_BDRE := $3000C,
    LIBHAL_STORAGE_ICON_DISC_HDDVDROM := $3000D,
    LIBHAL_STORAGE_ICON_DISC_HDDVDR := $3000E,
    LIBHAL_STORAGE_ICON_DISC_HDDVDRW := $3000F,
    LIBHAL_STORAGE_ICON_DISC_MRW := $30010,
    LIBHAL_STORAGE_ICON_DISC_MRWW := $30011,
    LIBHAL_STORAGE_ICON_DISC_MO := $30012
    );

  LibHalStoragePolicyIconPair = record
    icon: LibHalStoragePolicyIcon;
    icon_path: ^char;
  end;

function libhal_storage_policy_new: PLibHalStoragePolicy; cdecl; external External_library name 'libhal_storage_policy_new';

procedure libhal_storage_policy_free(policy: pLibHalStoragePolicy); cdecl; external External_library name 'libhal_storage_policy_free';

procedure libhal_storage_policy_set_icon_path(policy: pLibHalStoragePolicy; icon: LibHalStoragePolicyIcon; path: pchar); cdecl; external External_library name 'libhal_storage_policy_set_icon_path';

procedure libhal_storage_policy_set_icon_mapping(policy: pLibHalStoragePolicy; pairs: pLibHalStoragePolicyIconPair); cdecl; external External_library name 'libhal_storage_policy_set_icon_mapping';

function libhal_storage_policy_lookup_icon(policy: pLibHalStoragePolicy; icon: LibHalStoragePolicyIcon): Pchar; cdecl; external External_library name 'libhal_storage_policy_lookup_icon';

type

  LibHalDriveBus = (LIBHAL_DRIVE_BUS_UNKNOWN := $00, LIBHAL_DRIVE_BUS_IDE := $01,
    LIBHAL_DRIVE_BUS_SCSI := $02, LIBHAL_DRIVE_BUS_USB := $03,
    LIBHAL_DRIVE_BUS_IEEE1394 := $04, LIBHAL_DRIVE_BUS_CCW := $05
    );

  LibHalDriveType = (LIBHAL_DRIVE_TYPE_REMOVABLE_DISK := $00,
    LIBHAL_DRIVE_TYPE_DISK := $01, LIBHAL_DRIVE_TYPE_CDROM := $02,
    LIBHAL_DRIVE_TYPE_FLOPPY := $03, LIBHAL_DRIVE_TYPE_TAPE := $04,
    LIBHAL_DRIVE_TYPE_COMPACT_FLASH := $05,
    LIBHAL_DRIVE_TYPE_MEMORY_STICK := $06,
    LIBHAL_DRIVE_TYPE_SMART_MEDIA := $07,
    LIBHAL_DRIVE_TYPE_SD_MMC := $08, LIBHAL_DRIVE_TYPE_CAMERA := $09,
    LIBHAL_DRIVE_TYPE_PORTABLE_AUDIO_PLAYER := $0A,
    LIBHAL_DRIVE_TYPE_ZIP := $0B, LIBHAL_DRIVE_TYPE_JAZ := $0C,
    LIBHAL_DRIVE_TYPE_FLASHKEY := $0D,
    LIBHAL_DRIVE_TYPE_MO := $0E);

  LibHalDriveCdromCaps = (LIBHAL_DRIVE_CDROM_CAPS_CDROM := $00001,
    LIBHAL_DRIVE_CDROM_CAPS_CDR := $00002,
    LIBHAL_DRIVE_CDROM_CAPS_CDRW := $00004,
    LIBHAL_DRIVE_CDROM_CAPS_DVDRAM := $00008,
    LIBHAL_DRIVE_CDROM_CAPS_DVDROM := $00010,
    LIBHAL_DRIVE_CDROM_CAPS_DVDR := $00020,
    LIBHAL_DRIVE_CDROM_CAPS_DVDRW := $00040,
    LIBHAL_DRIVE_CDROM_CAPS_DVDPLUSR := $00080,
    LIBHAL_DRIVE_CDROM_CAPS_DVDPLUSRW := $00100,
    LIBHAL_DRIVE_CDROM_CAPS_DVDPLUSRDL := $00200,
    LIBHAL_DRIVE_CDROM_CAPS_DVDPLUSRWDL := $00400,
    LIBHAL_DRIVE_CDROM_CAPS_BDROM := $00800,
    LIBHAL_DRIVE_CDROM_CAPS_BDR := $01000,
    LIBHAL_DRIVE_CDROM_CAPS_BDRE := $02000,
    LIBHAL_DRIVE_CDROM_CAPS_HDDVDROM := $04000,
    LIBHAL_DRIVE_CDROM_CAPS_HDDVDR := $08000,
    LIBHAL_DRIVE_CDROM_CAPS_HDDVDRW := $10000,
    LIBHAL_DRIVE_CDROM_CAPS_MRW := $20000,
    LIBHAL_DRIVE_CDROM_CAPS_MRWW := $40000,
    LIBHAL_DRIVE_CDROM_CAPS_MO := $80000
    );

function libhal_drive_from_udi(hal_ctx: pLibHalContext; udi: pchar): PLibHalDrive; cdecl; external External_library name 'libhal_drive_from_udi';

function libhal_drive_from_device_file(hal_ctx: pLibHalContext; device_file: pchar): PLibHalDrive; cdecl; external External_library name 'libhal_drive_from_device_file';

procedure libhal_drive_free(drive: pLibHalDrive); cdecl; external External_library name 'libhal_drive_free';

function libhal_drive_is_hotpluggable(drive: pLibHalDrive): dbus_bool_t; cdecl; external External_library name 'libhal_drive_is_hotpluggable';

function libhal_drive_uses_removable_media(drive: pLibHalDrive): dbus_bool_t; cdecl; external External_library name 'libhal_drive_uses_removable_media';

function libhal_drive_is_media_detected(drive: pLibHalDrive): dbus_bool_t; cdecl; external External_library name 'libhal_drive_is_media_detected';

function libhal_drive_is_media_detection_automatic(drive: pLibHalDrive): dbus_bool_t; cdecl; external External_library name 'libhal_drive_is_media_detection_automatic';

function libhal_drive_get_size(drive: pLibHalDrive): dbus_uint64_t; cdecl; external External_library name 'libhal_drive_get_size';

function libhal_drive_get_media_size(drive: pLibHalDrive): dbus_uint64_t; cdecl; external External_library name 'libhal_drive_get_media_size';

function libhal_drive_get_partition_scheme(drive: pLibHalDrive): Pchar; cdecl; external External_library name 'libhal_drive_get_partition_scheme';

function libhal_drive_no_partitions_hint(drive: pLibHalDrive): dbus_bool_t; cdecl; external External_library name 'libhal_drive_no_partitions_hint';

function libhal_drive_requires_eject(drive: pLibHalDrive): dbus_bool_t; cdecl; external External_library name 'libhal_drive_requires_eject';

function libhal_drive_get_type(drive: pLibHalDrive): LibHalDriveType; cdecl; external External_library name 'libhal_drive_get_type';

function libhal_drive_get_bus(drive: pLibHalDrive): LibHalDriveBus; cdecl; external External_library name 'libhal_drive_get_bus';

function libhal_drive_get_cdrom_caps(drive: pLibHalDrive): LibHalDriveCdromCaps; cdecl; external External_library name 'libhal_drive_get_cdrom_caps';

function libhal_drive_get_device_major(drive: pLibHalDrive): dword; cdecl; external External_library name 'libhal_drive_get_device_major';

function libhal_drive_get_device_minor(drive: pLibHalDrive): dword; cdecl; external External_library name 'libhal_drive_get_device_minor';

function libhal_drive_get_type_textual(drive: pLibHalDrive): Pchar; cdecl; external External_library name 'libhal_drive_get_type_textual';

function libhal_drive_get_device_file(drive: pLibHalDrive): Pchar; cdecl; external External_library name 'libhal_drive_get_device_file';

function libhal_drive_get_udi(drive: pLibHalDrive): Pchar; cdecl; external External_library name 'libhal_drive_get_udi';

function libhal_drive_get_serial(drive: pLibHalDrive): Pchar; cdecl; external External_library name 'libhal_drive_get_serial';

function libhal_drive_get_firmware_version(drive: pLibHalDrive): Pchar; cdecl; external External_library name 'libhal_drive_get_firmware_version';

function libhal_drive_get_model(drive: pLibHalDrive): Pchar; cdecl; external External_library name 'libhal_drive_get_model';

function libhal_drive_get_vendor(drive: pLibHalDrive): Pchar; cdecl; external External_library name 'libhal_drive_get_vendor';

function libhal_drive_get_physical_device_udi(drive: pLibHalDrive): Pchar; cdecl; external External_library name 'libhal_drive_get_physical_device_udi';

function libhal_drive_get_dedicated_icon_drive(drive: pLibHalDrive): Pchar; cdecl; external External_library name 'libhal_drive_get_dedicated_icon_drive';

function libhal_drive_get_dedicated_icon_volume(drive: pLibHalDrive): Pchar; cdecl; external External_library name 'libhal_drive_get_dedicated_icon_volume';

function libhal_drive_policy_compute_display_name(drive: pLibHalDrive; volume: pLibHalVolume; policy: pLibHalStoragePolicy): Pchar; cdecl; external External_library name 'libhal_drive_policy_compute_display_name';

function libhal_drive_policy_compute_icon_name(drive: pLibHalDrive; volume: pLibHalVolume; policy: pLibHalStoragePolicy): Pchar; cdecl; external External_library name 'libhal_drive_policy_compute_icon_name';

function libhal_drive_policy_is_mountable(drive: pLibHalDrive; policy: pLibHalStoragePolicy): dbus_bool_t; cdecl; external External_library name 'libhal_drive_policy_is_mountable';

function libhal_drive_policy_get_desired_mount_point(drive: pLibHalDrive; policy: pLibHalStoragePolicy): Pchar; cdecl; external External_library name 'libhal_drive_policy_get_desired_mount_point';

function libhal_drive_policy_get_mount_options(drive: pLibHalDrive; policy: pLibHalStoragePolicy): Pchar; cdecl; external External_library name 'libhal_drive_policy_get_mount_options';

function libhal_drive_policy_get_mount_fs(drive: pLibHalDrive; policy: pLibHalStoragePolicy): Pchar; cdecl; external External_library name 'libhal_drive_policy_get_mount_fs';

function libhal_drive_find_all_volumes(hal_ctx: pLibHalContext; drive: pLibHalDrive; num_volumes: plongint): PPchar; cdecl; external External_library name 'libhal_drive_find_all_volumes';

function libhal_drive_policy_default_get_mount_root(hal_ctx: pLibHalContext): Pchar; cdecl; external External_library name 'libhal_drive_policy_default_get_mount_root';

function libhal_drive_policy_default_use_managed_keyword(hal_ctx: pLibHalContext): dbus_bool_t; cdecl; external External_library name 'libhal_drive_policy_default_use_managed_keyword';

function libhal_drive_policy_default_get_managed_keyword_primary(hal_ctx: pLibHalContext): Pchar; cdecl; external External_library name 'libhal_drive_policy_default_get_managed_keyword_primary';

function libhal_drive_policy_default_get_managed_keyword_secondary(hal_ctx: pLibHalContext): Pchar; cdecl; external External_library name 'libhal_drive_policy_default_get_managed_keyword_secondary';

type

  LibHalVolumeUsage = (LIBHAL_VOLUME_USAGE_MOUNTABLE_FILESYSTEM,
    LIBHAL_VOLUME_USAGE_PARTITION_TABLE,
    LIBHAL_VOLUME_USAGE_RAID_MEMBER, LIBHAL_VOLUME_USAGE_CRYPTO,
    LIBHAL_VOLUME_USAGE_UNKNOWN, LIBHAL_VOLUME_USAGE_OTHER
    );

  LibHalVolumeDiscType = (LIBHAL_VOLUME_DISC_TYPE_CDROM := $00,
    LIBHAL_VOLUME_DISC_TYPE_CDR := $01,
    LIBHAL_VOLUME_DISC_TYPE_CDRW := $02,
    LIBHAL_VOLUME_DISC_TYPE_DVDROM := $03,
    LIBHAL_VOLUME_DISC_TYPE_DVDRAM := $04,
    LIBHAL_VOLUME_DISC_TYPE_DVDR := $05,
    LIBHAL_VOLUME_DISC_TYPE_DVDRW := $06,
    LIBHAL_VOLUME_DISC_TYPE_DVDPLUSR := $07,
    LIBHAL_VOLUME_DISC_TYPE_DVDPLUSRW := $08,
    LIBHAL_VOLUME_DISC_TYPE_DVDPLUSR_DL := $09,
    LIBHAL_VOLUME_DISC_TYPE_BDROM := $0A,
    LIBHAL_VOLUME_DISC_TYPE_BDR := $0B,
    LIBHAL_VOLUME_DISC_TYPE_BDRE := $0C,
    LIBHAL_VOLUME_DISC_TYPE_HDDVDROM := $0D,
    LIBHAL_VOLUME_DISC_TYPE_HDDVDR := $0E,
    LIBHAL_VOLUME_DISC_TYPE_HDDVDRW := $0F,
    LIBHAL_VOLUME_DISC_TYPE_MO := $10,
    LIBHAL_VOLUME_DISC_TYPE_DVDR_DL := $11
    );

function libhal_volume_from_udi(hal_ctx: pLibHalContext; udi: pchar): PLibHalVolume; cdecl; external External_library name 'libhal_volume_from_udi';

function libhal_volume_from_device_file(hal_ctx: pLibHalContext; device_file: pchar): PLibHalVolume; cdecl; external External_library name 'libhal_volume_from_device_file';

function libhal_volume_from_mount_point(hal_ctx: pLibHalContext; mount_point: pchar): PLibHalVolume; cdecl; external External_library name 'libhal_volume_from_mount_point';

procedure libhal_volume_free(volume: pLibHalVolume); cdecl; external External_library name 'libhal_volume_free';

function libhal_volume_get_size(volume: pLibHalVolume): dbus_uint64_t; cdecl; external External_library name 'libhal_volume_get_size';

function libhal_volume_get_disc_capacity(volume: pLibHalVolume): dbus_uint64_t; cdecl; external External_library name 'libhal_volume_get_disc_capacity';

function libhal_volume_get_udi(volume: pLibHalVolume): Pchar; cdecl; external External_library name 'libhal_volume_get_udi';

function libhal_volume_get_device_file(volume: pLibHalVolume): Pchar; cdecl; external External_library name 'libhal_volume_get_device_file';

function libhal_volume_get_device_major(volume: pLibHalVolume): dword; cdecl; external External_library name 'libhal_volume_get_device_major';

function libhal_volume_get_device_minor(volume: pLibHalVolume): dword; cdecl; external External_library name 'libhal_volume_get_device_minor';

function libhal_volume_get_fstype(volume: pLibHalVolume): Pchar; cdecl; external External_library name 'libhal_volume_get_fstype';

function libhal_volume_get_fsversion(volume: pLibHalVolume): Pchar; cdecl; external External_library name 'libhal_volume_get_fsversion';

function libhal_volume_get_fsusage(volume: pLibHalVolume): LibHalVolumeUsage; cdecl; external External_library name 'libhal_volume_get_fsusage';

function libhal_volume_is_mounted(volume: pLibHalVolume): dbus_bool_t; cdecl; external External_library name 'libhal_volume_is_mounted';

function libhal_volume_is_mounted_read_only(volume: pLibHalVolume): dbus_bool_t; cdecl; external External_library name 'libhal_volume_is_mounted_read_only';

function libhal_volume_is_partition(volume: pLibHalVolume): dbus_bool_t; cdecl; external External_library name 'libhal_volume_is_partition';

function libhal_volume_is_disc(volume: pLibHalVolume): dbus_bool_t; cdecl; external External_library name 'libhal_volume_is_disc';

function libhal_volume_get_partition_scheme(volume: pLibHalVolume): Pchar; cdecl; external External_library name 'libhal_volume_get_partition_scheme';

function libhal_volume_get_partition_type(volume: pLibHalVolume): Pchar; cdecl; external External_library name 'libhal_volume_get_partition_type';

function libhal_volume_get_partition_label(volume: pLibHalVolume): Pchar; cdecl; external External_library name 'libhal_volume_get_partition_label';

function libhal_volume_get_partition_uuid(volume: pLibHalVolume): Pchar; cdecl; external External_library name 'libhal_volume_get_partition_uuid';

function libhal_volume_get_partition_flags(volume: pLibHalVolume): PPchar; cdecl; external External_library name 'libhal_volume_get_partition_flags';

function libhal_volume_get_partition_number(volume: pLibHalVolume): dword; cdecl; external External_library name 'libhal_volume_get_partition_number';

function libhal_volume_get_partition_start_offset(volume: pLibHalVolume): dbus_uint64_t; cdecl; external External_library name 'libhal_volume_get_partition_start_offset';

function libhal_volume_get_partition_media_size(volume: pLibHalVolume): dbus_uint64_t; cdecl; external External_library name 'libhal_volume_get_partition_media_size';

function libhal_volume_get_label(volume: pLibHalVolume): Pchar; cdecl; external External_library name 'libhal_volume_get_label';

function libhal_volume_get_mount_point(volume: pLibHalVolume): Pchar; cdecl; external External_library name 'libhal_volume_get_mount_point';

function libhal_volume_get_uuid(volume: pLibHalVolume): Pchar; cdecl; external External_library name 'libhal_volume_get_uuid';

function libhal_volume_get_storage_device_udi(volume: pLibHalVolume): Pchar; cdecl; external External_library name 'libhal_volume_get_storage_device_udi';

function libhal_volume_crypto_get_backing_volume_udi(volume: pLibHalVolume): Pchar; cdecl; external External_library name 'libhal_volume_crypto_get_backing_volume_udi';

function libhal_volume_crypto_get_clear_volume_udi(hal_ctx: pLibHalContext; volume: pLibHalVolume): Pchar; cdecl; external External_library name 'libhal_volume_crypto_get_clear_volume_udi';

function libhal_volume_disc_has_audio(volume: pLibHalVolume): dbus_bool_t; cdecl; external External_library name 'libhal_volume_disc_has_audio';

function libhal_volume_disc_has_data(volume: pLibHalVolume): dbus_bool_t; cdecl; external External_library name 'libhal_volume_disc_has_data';

function libhal_volume_disc_is_blank(volume: pLibHalVolume): dbus_bool_t; cdecl; external External_library name 'libhal_volume_disc_is_blank';

function libhal_volume_disc_is_rewritable(volume: pLibHalVolume): dbus_bool_t; cdecl; external External_library name 'libhal_volume_disc_is_rewritable';

function libhal_volume_disc_is_appendable(volume: pLibHalVolume): dbus_bool_t; cdecl; external External_library name 'libhal_volume_disc_is_appendable';

function libhal_volume_get_disc_type(volume: pLibHalVolume): LibHalVolumeDiscType; cdecl; external External_library name 'libhal_volume_get_disc_type';

function libhal_volume_get_msdos_part_table_type(volume: pLibHalVolume): longint; cdecl; external External_library name 'libhal_volume_get_msdos_part_table_type';

function libhal_volume_get_msdos_part_table_start(volume: pLibHalVolume): dbus_uint64_t; cdecl; external External_library name 'libhal_volume_get_msdos_part_table_start';

function libhal_volume_get_msdos_part_table_size(volume: pLibHalVolume): dbus_uint64_t; cdecl; external External_library name 'libhal_volume_get_msdos_part_table_size';

function libhal_volume_should_ignore(volume: pLibHalVolume): dbus_bool_t; cdecl; external External_library name 'libhal_volume_should_ignore';

function libhal_volume_policy_compute_size_as_string(volume: pLibHalVolume): Pchar; cdecl; external External_library name 'libhal_volume_policy_compute_size_as_string';

function libhal_volume_policy_compute_display_name(drive: pLibHalDrive; volume: pLibHalVolume; policy: pLibHalStoragePolicy): Pchar; cdecl; external External_library name 'libhal_volume_policy_compute_display_name';

function libhal_volume_policy_compute_icon_name(drive: pLibHalDrive; volume: pLibHalVolume; policy: pLibHalStoragePolicy): Pchar; cdecl; external External_library name 'libhal_volume_policy_compute_icon_name';

function libhal_volume_policy_should_be_visible(drive: pLibHalDrive; volume: pLibHalVolume; policy: pLibHalStoragePolicy; target_mount_point: pchar): dbus_bool_t; cdecl; external External_library name 'libhal_volume_policy_should_be_visible';

function libhal_volume_policy_is_mountable(drive: pLibHalDrive; volume: pLibHalVolume; policy: pLibHalStoragePolicy): dbus_bool_t; cdecl; external External_library name 'libhal_volume_policy_is_mountable';

function libhal_volume_policy_get_desired_mount_point(drive: pLibHalDrive; volume: pLibHalVolume; policy: pLibHalStoragePolicy): Pchar; cdecl; external External_library name 'libhal_volume_policy_get_desired_mount_point';

function libhal_volume_policy_get_mount_options(drive: pLibHalDrive; volume: pLibHalVolume; policy: pLibHalStoragePolicy): Pchar; cdecl; external External_library name 'libhal_volume_policy_get_mount_options';

function libhal_volume_policy_get_mount_fs(drive: pLibHalDrive; volume: pLibHalVolume; policy: pLibHalStoragePolicy): Pchar; cdecl; external External_library name 'libhal_volume_policy_get_mount_fs';

implementation

end.
